/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.108 Revision 1.134
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.108 2011/09/23 04:14:38 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.134 2012/05/20 12:31:32 vapier Exp $
4 4
5# @ECLASS: autotools.eclass 5# @ECLASS: autotools.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts 8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass is for safely handling autotooled software packages that need to 10# This eclass is for safely handling autotooled software packages that need to
11# regenerate their build scripts. All functions will abort in case of errors. 11# regenerate their build scripts. All functions will abort in case of errors.
12 12
13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
18
13inherit eutils libtool 19inherit libtool
14 20
15# @ECLASS-VARIABLE: WANT_AUTOCONF 21# @ECLASS-VARIABLE: WANT_AUTOCONF
16# @DESCRIPTION: 22# @DESCRIPTION:
17# The major version of autoconf your package needs 23# The major version of autoconf your package needs
18: ${WANT_AUTOCONF:=latest} 24: ${WANT_AUTOCONF:=latest}
29 35
30# @ECLASS-VARIABLE: _LATEST_AUTOMAKE 36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
31# @INTERNAL 37# @INTERNAL
32# @DESCRIPTION: 38# @DESCRIPTION:
33# CONSTANT! 39# CONSTANT!
34# The latest major version/slot of automake available on each arch. 40# The latest major version/slot of automake available on each arch. #312315
35# If a newer version is stable on any arch, and is NOT reflected in this list, 41# If a newer slot is stable on any arch, and is NOT reflected in this list,
36# then circular dependencies may arise during emerge @system bootstraps. 42# then circular dependencies may arise during emerge @system bootstraps.
37# Do NOT change this variable in your ebuilds! 43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
38_LATEST_AUTOMAKE='1.11' 46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
39 47
40_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
41_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
42if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
43 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
44 none) _automake_atom="" ;; # some packages don't require automake at all 52 # Even if the package doesn't use automake, we still need to depend
45 # if you change the "latest" version here, change also autotools_run_tool 53 # on it because we run aclocal to process m4 macros. This matches
46 # this MUST reflect the latest stable major version for each arch! 54 # the autoreconf tool, so this requirement is correct. #401605
55 none) ;;
56 latest)
57 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
58 if [[ ${EAPI:-0} != 0 ]] ; then
59 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
60 else
47 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;; 61 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
62 fi
63 ;;
48 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 64 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
49 esac 65 esac
50 export WANT_AUTOMAKE 66 export WANT_AUTOMAKE
51fi 67fi
52 68
53if [[ -n ${WANT_AUTOCONF} ]] ; then 69if [[ -n ${WANT_AUTOCONF} ]] ; then
54 case ${WANT_AUTOCONF} in 70 case ${WANT_AUTOCONF} in
55 none) _autoconf_atom="" ;; # some packages don't require autoconf at all 71 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
56 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 72 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
57 # if you change the latest version here, change also autotools_run_tool 73 # if you change the "latest" version here, change also autotools_env_setup
58 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;; 74 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
59 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;; 75 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
60 esac 76 esac
61 export WANT_AUTOCONF 77 export WANT_AUTOCONF
62fi 78fi
63 79
90# @DEFAULT_UNSET 106# @DEFAULT_UNSET
91# @DESCRIPTION: 107# @DESCRIPTION:
92# Additional options to pass to automake during 108# Additional options to pass to automake during
93# eautoreconf call. 109# eautoreconf call.
94 110
111# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
112# @DEFAULT_UNSET
113# @DESCRIPTION:
114# Don't run eautomake command if set to 'yes'; only used to workaround
115# broken packages. Generally you should, instead, fix the package to
116# not call AM_INIT_AUTOMAKE if it doesn't actually use automake.
117
95# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE 118# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
96# @DEFAULT_UNSET 119# @DEFAULT_UNSET
97# @DESCRIPTION: 120# @DESCRIPTION:
98# Don't run elibtoolize command if set to 'yes', 121# Don't run elibtoolize command if set to 'yes',
99# useful when elibtoolize needs to be ran with 122# useful when elibtoolize needs to be ran with
100# particular options 123# particular options
101 124
102# XXX: M4DIR should be deprecated
103# @ECLASS-VARIABLE: AT_M4DIR 125# @ECLASS-VARIABLE: AT_M4DIR
104# @DESCRIPTION: 126# @DESCRIPTION:
105# Additional director(y|ies) aclocal should search 127# Additional director(y|ies) aclocal should search
106: ${AT_M4DIR:=${M4DIR}} 128: ${AT_M4DIR:=}
129
130# @ECLASS-VARIABLE: AT_SYS_M4DIR
131# @INTERNAL
132# @DESCRIPTION:
133# For system integrators, a list of additional aclocal search paths.
134# This variable gets eval-ed, so you can use variables in the definition
135# that may not be valid until eautoreconf & friends are run.
136: ${AT_SYS_M4DIR:=}
107 137
108# @FUNCTION: eautoreconf 138# @FUNCTION: eautoreconf
109# @DESCRIPTION: 139# @DESCRIPTION:
110# This function mimes the behavior of autoreconf, but uses the different 140# This function mimes the behavior of autoreconf, but uses the different
111# eauto* functions to run the tools. It doesn't accept parameters, but 141# eauto* functions to run the tools. It doesn't accept parameters, but
112# the directory with include files can be specified with AT_M4DIR variable. 142# the directory with include files can be specified with AT_M4DIR variable.
113# 143#
114# Should do a full autoreconf - normally what most people will be interested in. 144# Should do a full autoreconf - normally what most people will be interested in.
115# Also should handle additional directories specified by AC_CONFIG_SUBDIRS. 145# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
116eautoreconf() { 146eautoreconf() {
117 local x auxdir g 147 local x g
118 148
119 if [[ -z ${AT_NO_RECURSIVE} ]]; then 149 if [[ -z ${AT_NO_RECURSIVE} ]]; then
120 # Take care of subdirs 150 # Take care of subdirs
121 for x in $(autotools_get_subdirs); do 151 for x in $(autotools_get_subdirs); do
122 if [[ -d ${x} ]] ; then 152 if [[ -d ${x} ]] ; then
125 popd >/dev/null 155 popd >/dev/null
126 fi 156 fi
127 done 157 done
128 fi 158 fi
129 159
130 auxdir=$(autotools_get_auxdir) 160 local auxdir=$(autotools_get_auxdir)
161 local macdir=$(autotools_get_macrodir)
131 162
132 einfo "Running eautoreconf in '${PWD}' ..." 163 einfo "Running eautoreconf in '${PWD}' ..."
133 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 164 [[ -n ${auxdir}${macdir} ]] && mkdir -p ${auxdir} ${macdir}
134 eaclocal 165 eaclocal
166 if grep -q '^AM_GNU_GETTEXT_VERSION' configure.?? ; then
167 eautopoint --force
168 fi
135 [[ ${CHOST} == *-darwin* ]] && g=g 169 [[ ${CHOST} == *-darwin* ]] && g=g
136 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then 170 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
137 _elibtoolize --copy --force --install 171 _elibtoolize --copy --force --install
138 else 172 else
139 _elibtoolize --copy --force 173 _elibtoolize --copy --force
140 fi 174 fi
141 eautoconf 175 eautoconf
142 eautoheader 176 eautoheader
143 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 177 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
144 178
145 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 179 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
146 180
147 # Call it here to prevent failures due to elibtoolize called _before_ 181 # Call it here to prevent failures due to elibtoolize called _before_
148 # eautoreconf. We set $S because elibtoolize runs on that #265319 182 # eautoreconf. We set $S because elibtoolize runs on that #265319
149 S=${PWD} elibtoolize 183 S=${PWD} elibtoolize --force
150 184
151 return 0 185 return 0
152} 186}
153 187
154# @FUNCTION: eaclocal_amflags 188# @FUNCTION: eaclocal_amflags
186# without e prefix. 220# without e prefix.
187# They also force installing the support files for safety. 221# They also force installing the support files for safety.
188# Respects AT_M4DIR for additional directories to search for macro's. 222# Respects AT_M4DIR for additional directories to search for macro's.
189eaclocal() { 223eaclocal() {
190 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 224 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
191 autotools_run_tool aclocal $(autotools_m4dir_include) "$@" $(eaclocal_amflags) 225 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
192} 226}
193 227
194# @FUNCTION: _elibtoolize 228# @FUNCTION: _elibtoolize
195# @DESCRIPTION: 229# @DESCRIPTION:
196# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from 230# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
215# @DESCRIPTION: 249# @DESCRIPTION:
216# Runs autoheader. 250# Runs autoheader.
217eautoheader() { 251eautoheader() {
218 # Check if we should run autoheader 252 # Check if we should run autoheader
219 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 253 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
220 NO_FAIL=1 autotools_run_tool autoheader $(autotools_m4dir_include) "$@" 254 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
221} 255}
222 256
223# @FUNCTION: eautoconf 257# @FUNCTION: eautoconf
224# @DESCRIPTION: 258# @DESCRIPTION:
225# Runs autoconf. 259# Runs autoconf.
229 eerror "No configure.{ac,in} present in '${PWD}'!" 263 eerror "No configure.{ac,in} present in '${PWD}'!"
230 echo 264 echo
231 die "No configure.{ac,in} present!" 265 die "No configure.{ac,in} present!"
232 fi 266 fi
233 267
234 autotools_run_tool autoconf $(autotools_m4dir_include) "$@" 268 autotools_run_tool --at-m4flags autoconf "$@"
235} 269}
236 270
237# @FUNCTION: eautomake 271# @FUNCTION: eautomake
238# @DESCRIPTION: 272# @DESCRIPTION:
239# Runs automake. 273# Runs automake.
241 local extra_opts 275 local extra_opts
242 local makefile_name 276 local makefile_name
243 277
244 # Run automake if: 278 # Run automake if:
245 # - a Makefile.am type file exists 279 # - a Makefile.am type file exists
246 # - a Makefile.in type file exists and the configure
247 # script is using the AM_INIT_AUTOMAKE directive 280 # - the configure script is using the AM_INIT_AUTOMAKE directive
248 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do 281 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
249 [[ -f ${makefile_name} ]] && break 282 [[ -f ${makefile_name} ]] && break
250 done 283 done
251 [[ -z ${makefile_name} ]] && return 0
252 284
253 if [[ ${makefile_name} == *.in ]] ; then 285 if [[ -z ${makefile_name} ]] ; then
254 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then 286 # Really we should just use autotools_check_macro ...
287 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
288 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
255 return 0 289 return 0
256 fi 290 fi
257 291
258 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then 292 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
259 local used_automake 293 local used_automake
270 eautoreconf 304 eautoreconf
271 return 0 305 return 0
272 fi 306 fi
273 fi 307 fi
274 308
275 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 309 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
276 || extra_opts="${extra_opts} --foreign" 310 || extra_opts="${extra_opts} --foreign"
277 311
278 # --force-missing seems not to be recognized by some flavours of automake 312 # --force-missing seems not to be recognized by some flavours of automake
279 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 313 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
280} 314}
284# Runs autopoint (from the gettext package). 318# Runs autopoint (from the gettext package).
285eautopoint() { 319eautopoint() {
286 autotools_run_tool autopoint "$@" 320 autotools_run_tool autopoint "$@"
287} 321}
288 322
323# @FUNCTION: config_rpath_update
324# @USAGE: [destination]
325# @DESCRIPTION:
326# Some packages utilize the config.rpath helper script, but don't
327# use gettext directly. So we have to copy it in manually since
328# we can't let `autopoint` do it for us.
329config_rpath_update() {
330 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
331
332 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
333 [[ $# -eq 0 ]] && return 0
334
335 einfo "Updating all config.rpath files"
336 for dst in "$@" ; do
337 einfo " ${dst}"
338 cp "${src}" "${dst}" || die
339 done
340}
341
289# Internal function to run an autotools' tool 342# Internal function to run an autotools' tool
290autotools_env_setup() { 343autotools_env_setup() {
291 # We do the latest → version switch here because it solves 344 # We do the "latest" → version switch here because it solves
292 # possible order problems, see bug #270010 as an example. 345 # possible order problems, see bug #270010 as an example.
293 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 346 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
294 local pv 347 local pv
295 for pv in ${_LATEST_AUTOMAKE} ; do 348 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
296 # has_version respects ROOT, but in this case, we don't want it to, 349 # has_version respects ROOT, but in this case, we don't want it to,
297 # thus "ROOT=/" prefix: 350 # thus "ROOT=/" prefix:
298 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv" 351 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
299 done 352 done
300 [[ ${WANT_AUTOMAKE} == "latest" ]] && \ 353 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
301 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}" 354 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
302 fi 355 fi
303 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5 356 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
304} 357}
305autotools_run_tool() { 358autotools_run_tool() {
359 # Process our own internal flags first
360 local autofail=true m4flags=false
361 while [[ -n $1 ]] ; do
362 case $1 in
363 --at-no-fail) autofail=false;;
364 --at-m4flags) m4flags=true;;
365 # whatever is left goes to the actual tool
366 *) break;;
367 esac
368 shift
369 done
370
306 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then 371 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
307 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase" 372 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
308 fi 373 fi
309 374
310 autotools_env_setup 375 autotools_env_setup
319 [[ -e ${STDERR_TARGET} ]] || break 384 [[ -e ${STDERR_TARGET} ]] || break
320 : $(( i++ )) 385 : $(( i++ ))
321 done 386 done
322 fi 387 fi
323 388
389 if ${m4flags} ; then
390 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
391 fi
392
324 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}" 393 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
325 394
326 ebegin "Running $@" 395 ebegin "Running $@"
327 "$@" >> "${STDERR_TARGET}" 2>&1 396 "$@" >> "${STDERR_TARGET}" 2>&1
328 eend $? 397 if ! eend $? && ${autofail} ; then
329
330 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
331 echo 398 echo
332 eerror "Failed Running $1 !" 399 eerror "Failed Running $1 !"
333 eerror 400 eerror
334 eerror "Include in your bugreport the contents of:" 401 eerror "Include in your bugreport the contents of:"
335 eerror 402 eerror
347 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null 414 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
348 done 415 done
349 return 0 416 return 0
350} 417}
351 418
419# Internal function to look for a macro and extract its value
420autotools_check_macro_val() {
421 local macro=$1 scan_out
422
423 autotools_check_macro "${macro}" | \
424 gawk -v macro="${macro}" \
425 '($0 !~ /^[[:space:]]*(#|dnl)/) {
426 if (match($0, macro ":(.*)$", res))
427 print res[1]
428 }' | uniq
429
430 return 0
431}
432
352# Internal function to get additional subdirs to configure 433# Internal function to get additional subdirs to configure
353autotools_get_subdirs() { 434autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
354 local subdirs_scan_out 435autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
436autotools_get_macrodir() { autotools_check_macro_val AC_CONFIG_MACRO_DIR ; }
355 437
356 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
357 [[ -n ${subdirs_scan_out} ]] || return 0
358
359 echo "${subdirs_scan_out}" | gawk \
360 '($0 !~ /^[[:space:]]*(#|dnl)/) {
361 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
362 print res[1]
363 }' | uniq
364
365 return 0
366}
367
368autotools_get_auxdir() {
369 local auxdir_scan_out
370
371 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
372 [[ -n ${auxdir_scan_out} ]] || return 0
373
374 echo ${auxdir_scan_out} | gawk \
375 '($0 !~ /^[[:space:]]*(#|dnl)/) {
376 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
377 print res[1]
378 }' | uniq
379
380 return 0
381}
382
383autotools_m4dir_include() { 438_autotools_m4dir_include() {
384 [[ -n ${AT_M4DIR} ]] || return
385
386 local include_opts= 439 local x include_opts
387 440
388 for x in ${AT_M4DIR} ; do 441 for x in "$@" ; do
389 case "${x}" in 442 case ${x} in
390 "-I")
391 # We handle it below 443 # We handle it below
392 ;; 444 -I) ;;
393 *) 445 *)
394 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist" 446 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
395 include_opts="${include_opts} -I ${x}" 447 include_opts+=" -I ${x}"
396 ;; 448 ;;
397 esac 449 esac
398 done 450 done
399 451
400 echo $include_opts 452 echo ${include_opts}
401} 453}
454autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
455autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
456
457fi

Legend:
Removed from v.1.108  
changed lines
  Added in v.1.134

  ViewVC Help
Powered by ViewVC 1.1.20